'******************************************************************************
'*  cpm.spin - demo mode for the qz80 core
'*
'*  (c) Juergen Buchmueller <pullmoll@t-online.de>
'*
'* $Id: cpm.spin,v 1.3 2010-04-12 12:18:38 pm Exp $
'******************************************************************************
CON
	_xinfreq		= 5_000_000		' Quartz is 5MHz
'	_xinfreq		= 6_500_000		' Quartz is 6.5MHz
	_clkmode		= xtal1 + pll16x	' System clock is 80MHz/96MHz

'' Define if you want to run this on the TriBladeProp #2,
'' on the RamBladeProp or on the DracBladeProp
'#define TriBladeProp
'#define RamBladeProp
#define DracBladeProp

' Select your video norm
'#define NTSC
#define PAL

' Uncomment to have debug code inserted
'#define DEBUG

' Uncomment to emulate interrupts (NMI and IRQ)
'#define INTERRUPTS

' Uncomment to support SIMH banked memory
'#define BANKED_MEM

' Uncomment to count R register
#define COUNT_R

#ifdef TriBladeProp
' serial I/O pins on the TriBladeProp #2
	SI			= 31
	SO			= 30
	SI2			= -1
	SO2			= -1
' Keyboard pins
#define HAVE_KBD
	kbDpin			= 26
	kbCpin			= 27
' SD pins on the TriBladeProp #2
#define HAVE_SD
	doPin			= 9
	clkPin			= 28
	diPin			= 8
	csPin			= 14
' VGA pins on the TriBladeProp #2 - none?
#undef  HAVE_VGA
	vgaPin			= 16
#endif TriBladeProp

#ifdef RamBladeProp
' serial I/O pins on the RamBladeProp (secondary?)
	SI			= 23
	SO			= 22
	SI2			= -1
	SO2			= -1
' Keyboard pins
#undef HAVE_KBD
	kbDpin			= -1
	kbCpin			= -1
' microSD pins on RamBladeProp
#define HAVE_SD
	doPin			= 24
	clkPin			= 26
	diPin			= 25
	csPin			= 19
' VGA pins on the RamBladeProp - none
	vgaPin			= -1
#undef  HAVE_VGA
' TV pins on the RamBladeProp - none
#undef  HAVE_TV
	tvPin			= -1
#endif RamBladeProp

#ifdef DracBladeProp
' serial I/O pins on the DracBladeProp
	SI			= 31
	SO			= 30
	SI2			= 25
	SO2			= 24
' Keyboard pins
#define HAVE_KBD
	kbDpin			= 26
	kbCpin			= 27
' SD pins on the DracBladeProp
#define HAVE_SD
	doPin			= 12
	clkPin			= 13
	diPin			= 14
	csPin			= 15
' VGA pins on the DracBladeProp - 16-23
#define HAVE_VGA
	vgaPin			= 16
' TV pins on the DracBladeProp - 16-19; use 18 for the 1 pin TV out
'#define HAVE_TV
	tvPin			= 18
#endif DracBladeProp


VAR
	byte	pins[12]
	long	params[3]
#ifdef INTERRUPTS
	long	irq
#endif INTERRUPTS

OBJ
	io	: "io"
        qz80	: "qz80"

PUB     main : okay
	' fill the pins array
	pins[ 0] := SI
	pins[ 1] := SO
	pins[ 2] := SI2
	pins[ 3] := SO2
	pins[ 4] := doPin
	pins[ 5] := clkPin
	pins[ 6] := diPin
	pins[ 7] := csPin
	pins[ 8] := kbDpin
	pins[ 9] := kbCpin
	pins[10] := vgaPin
	pins[11] := tvPin
        okay := \io.start(@pins)
	if okay < 0
		repeat

	params[0] := io.command_addr
#ifdef INTERRUPTS
	params[1] := @irq
#endif INTERRUPTS
	io.str(string("Going to start qz80. Goodbye Spin!",13,10))
	' This call won't return as it starts in cog 0
	qz80.start(@params)
